/* notas.c - generar una secuencia de notas */
#include <stdio.h>
#include <math.h>
#include <time.h>
#define NUM 13

void sistemaAlturas(int, int, float, float []);
void tiempos(int, int, float []);
void secuencia(int, int []);

main(){
	int i, cantNotas = 5, bpm = 60;
	float alturas[NUM], duraciones[cantNotas];

	srand(time(NULL));
	
	/* Se inicializa el arreglo de alturas */
	sistemaAlturas(3, NUM, 440.0, alturas);
	
	/* Se calculan las duraciones */
	tiempos(bpm, cantNotas, duraciones);
	
	/* Se despliega la secuencia de notas */
	printf("Frecuencia(Hz)\t Duracion(s) \n");
	for (i = 0; i < cantNotas; i++)
		printf("%14.3f\t %11.3f\n", alturas[rand() % NUM], duraciones[i]);

	return 0;	
}
void sistemaAlturas(int intervalo, int cantidadIntervalos, float frecuencia, float arreglo[]){
  int i;
  
  for(i = 0; i < cantidadIntervalos; i++){
	arreglo[i] = frecuencia;
	frecuencia *= pow(intervalo, 1.0 / cantidadIntervalos);
   }
}
void tiempos(int bpm, int cantDuraciones, float duraciones[]){
  int i, num, den, numeradores[cantDuraciones], denominadores[] = {4, 8, 16};
 
  /* se genera la secuencia de numeradores */
  secuencia(cantDuraciones, numeradores);  
  
  for (i = 0; i < cantDuraciones; i++){
    num = numeradores[i];
    den = denominadores[rand() % 3];
    duraciones[i] = (float) num / den * 4 * 60 / bpm;  
  } 

}

void secuencia(int cant, int secuencia []){
	
	int i, j, a[cant], b[cant], c[cant], d[cant];
	float phi = 1.618, numFlt;
	
	c[0] = 1;
	
	/* se generan las secuencias a, b y c */	
	for (i = 1; i <= cant; i++){
		a[i-1] = i;
		numFlt = phi * i;     /* se calcula el producto en float */
		b[i-1] = (int)numFlt; /* se trunca a entero */
		if (i != 1)
		  c[i-1] = b[i-1] - b[i-2];
	}

	/* se recorre b para cada elemento de a y se genera d */	
	for (i = 1; i <= cant; i++){
          d[i-1] = 0;
	  for (j = 1; j <= cant; j++){
	    if (a[i-1] == b[j-1])
	      d[i-1] = 1;
	   }
	}	  

	/* se genera e y se despliegan las secuencias */	
	for (i = 1; i <= cant; i++){
	  secuencia[i-1] = c[i-1] - d[i-1] + 1;	
	  /* printf("%d \t %d\t %d\t %d\t %d\n", a[i-1], b[i-1], c[i-1], d[i-1], secuencia[i-1]); */
	  
	}

}
